package fr.itsonus.bousoleplussbackend.models;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import lombok.ToString;
import org.hibernate.Hibernate;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.Objects;
import java.util.Set;

@Getter
@Setter
@ToString
@RequiredArgsConstructor
@Entity
public class Axe {

    @Id
    @GeneratedValue
    private Long id;

    private Integer identifier;

    @NotBlank
    @Size(max = 50)
    private String shortTitle;

    @NotBlank
    @Size(max = 100)
    private String title;

    @Size(max = 500)
    private String description;

    @NotBlank
    private String color;

    @OneToMany(mappedBy = "axe")
    @ToString.Exclude
    @JsonIgnore
    private Set<Question> questions;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o)) return false;
        Axe axe = (Axe) o;
        return id != null && Objects.equals(id, axe.id);
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
}
