import {RestLinks} from "~/repositories/models/rest-response.model";

export interface Score {
  scoreAvg: number;
  axeIdentifier: number;
}

export interface ResponseWithQuestion extends RestLinks {
  axeIdentifier: number;
  question: string;
  score: number;
  comment: string;
}

export interface Quiz extends RestLinks {
  id: number;
  createdDate: string;
  scores: Score[];
  _embedded: {
    responses: ResponseWithQuestion[]
  };
}

export interface Response {
  axeId: number;
  questionId: number;
  score?: number;
  comment?: string;
}

export interface QuizRate {
  score?: number;
  comment?: string;
}
